import{z as e}from"zod";import{format as r}from"date-fns";function a(a,i){let t;const o=`O campo ${i.label} é obrigatório`;switch(i.type){case"email":t=e.string({required_error:o}).trim().email(`O campo ${i.label} não possui um e-mail valido.`);break;case"password":{let r=e.string({required_error:o});i.required&&(r=r.min(6,`O campo ${i.label} precisa ter ao menos 6 caracteres.`)),t=r;break}case"text":{let r=e.string({required_error:o}).trim();i.required&&(r=r.min(1,o)),void 0!==i.maxLength&&(r=r.max(i.maxLength,`O campo ${i.label} não atende a quantidade máxima de ${i.maxLength} caracteres`)),t=r;break}case"select":{let r=e.string({required_error:o}).or(e.number({required_error:o}));i.required&&(r=e.string({required_error:o}).min(1,o).or(e.number({required_error:o}).min(1,o))),t=r.refine((e=>!e||void 0!==i.pagination||void 0!==i.onSearch||i.options?.some((r=>r.value.toString()===e.toString()))),"Selecione uma opção válida");break}case"switch":case"checkbox":{const r=e.boolean({required_error:o});t=i.required?r.refine((e=>!0===e),{message:o}):r;break}case"multi-select":{let r=e.union([e.string(),e.number()]).array();i.required&&(r=r.min(1,o)),t=r.refine((e=>0===e.length||!e||void 0!==i.pagination||void 0!==i.onSearch||e.every((e=>i.options?.some((r=>r.value.toString()===e.toString()))))),{message:"Selecione ao menos uma opção válida"});break}case"multi-checkbox":{let r=e.union([e.string(),e.number()]).array();i.required&&(r=r.min(1,o)),t=r.refine((e=>0===e.length||!e||e.every((e=>i.options?.some((r=>r.value.toString()===e.toString()))))),{message:"Selecione ao menos uma opção válida"});break}case"date":{let a=e.date({required_error:o,description:o,invalid_type_error:o});void 0!==i.min&&(a=a.min(new Date(i.min.getFullYear(),i.min.getMonth(),i.min.getDate()),`O campo ${i.label} não atende a data mínima de ${r(i.min,"dd/MM/yyyy")}`)),void 0!==i.max&&(a=a.max(new Date(i.max.getFullYear(),i.max.getMonth(),i.max.getDate()),`O campo ${i.label} não atende a data máxima de ${r(i.max,"dd/MM/yyyy")}`)),t=a;break}case"datetime":{let a=e.date({required_error:o,description:o,invalid_type_error:o});void 0!==i.min&&(a=a.min(new Date(i.min.getFullYear(),i.min.getMonth(),i.min.getDate(),i.min.getHours(),i.min.getMinutes()),`O campo ${i.label} não atende a data mínima de ${r(i.min,"dd/MM/yyyy HH:mm")}`)),void 0!==i.max&&(a=a.max(new Date(i.max.getFullYear(),i.max.getMonth(),i.max.getDate(),i.max.getHours(),i.max.getMinutes()),`O campo ${i.label} não atende a data máxima de ${r(i.max,"dd/MM/yyyy HH:mm")}`)),t=a;break}case"time":t=e.date({required_error:o,description:o,invalid_type_error:o}).refine((e=>void 0===i.min||e.getHours()>i.min.getHours()||e.getHours()===i.min.getHours()&&e.getMinutes()>=i.min.getMinutes()),`O campo ${i.label} não atende o tempo mínimo de ${r(i.min||new Date,"HH:mm")}`).refine((e=>void 0===i.max||e.getHours()<i.max.getHours()||e.getHours()===i.max.getHours()&&e.getMinutes()<=i.max.getMinutes()),`O campo ${i.label} não atende o tempo máximo de ${r(i.max||new Date,"HH:mm")}`);break;case"month":t=e.date({required_error:o,description:o,invalid_type_error:o}).refine((e=>void 0===i.min||e.getFullYear()>i.min.getFullYear()||e.getFullYear()===i.min.getFullYear()&&e.getMonth()>=i.min.getMonth()),`O campo ${i.label} não atende o período mínimo de ${r(i.min||new Date,"MM/yyyy")}`).refine((e=>void 0===i.max||e.getFullYear()<i.max.getFullYear()||e.getFullYear()===i.max.getFullYear()&&e.getMonth()<=i.max.getMonth()),`O campo ${i.label} não atende o período máximo de ${r(i.max||new Date,"MM/yyyy")}`);break;case"number":{let r=e.coerce.number({required_error:o,invalid_type_error:o});void 0!==i.min&&(r=r.min(i.min,`O campo ${i.label} não atende o valor mínimo de ${i.min}`)),void 0!==i.max&&(r=r.max(i.max,`O campo ${i.label} não atende o valor máximo de ${i.max}`)),t=r.refine((e=>!i.required||!Number.isNaN(e)),o);break}case"color":{let r=e.string({required_error:o});a&&(r=r.regex(/^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/,"Informe uma cor válida")),i.required&&(r=r.min(1,o)),t=r;break}case"hyperlink":{let r=e.object({label:e.string().trim().transform((e=>i.formatText?"upperCase"===i.formatText?e.toUpperCase():"lowerCase"===i.formatText?e.toLowerCase():e.charAt(0).toUpperCase()+e.slice(1).toLowerCase():e)),value:e.string().trim()}).array();i.required&&(r=r.min(1,o)),t=r;break}case"dynamic-checkbox":{let r=e.object({label:e.string().trim(),value:e.boolean()}).array();i.required&&(r=r.min(1,o)),t=r;break}case"rate":t=e.coerce.number({required_error:o,invalid_type_error:o}).max(i.max||5,`O campo ${i.label} não atende o valor máximo de ${i.max}`).refine((e=>!i.required||Boolean(e)),o);break;default:t=e.any()}if(t){i.required&&!i.hidden||(t=t.nullish());const e=t.safeParse(a);if(!1===e.success)return e.error.issues.map((e=>e.message)).join("\n");if(i.validate)return i.validate(a)}}export{a as validateField};
//# sourceMappingURL=validations.esm.js.map
